//=============================================================================
// CHealth.
//=============================================================================
class CHealth expands TournamentPickup config (MH2_NS_V2);

var config int MaxHealth;
var config int HealingAmount;
var() bool bSuperHeal;

event float BotDesireability(Pawn Bot)
{
	local float desire;

	if (bSuperHeal) MaxHealth = Min(MaxHealth, MaxHealth * 2.0);
	desire = Min(HealingAmount, MaxHealth - Bot.Health);

	if ( (Bot.Weapon != None) && (Bot.Weapon.AIRating > 0.5) )
		desire *= 1.7;
	if ( Bot.Health < 45 )
		return ( FMin(0.03 * desire, 2.2) );
	else
	{
		if ( desire > 6 )
		desire = FMax(desire,25);
		return ( FMin(0.017 * desire, 2.0) );
	}
}

function PlayPickupMessage(Pawn Other)
{
	Other.ReceiveLocalizedMessage( class'PickupMessageHealthPlus', 0, None, None, Self.Class );
}

auto state Pickup
{
	function Touch( actor Other )
	{
		local Pawn P;

//		log(self@"pickup");

		if ( ValidTouch(Other) )
		{
			P = Pawn(Other);
			if (bSuperHeal) //Not used
				MaxHealth = Min(MaxHealth, MaxHealth * 2.0);
			if (P.Health < MaxHealth)
			{
				if (Level.Game.LocalLog != None)
					Level.Game.LocalLog.LogPickup(Self, P);
				if (Level.Game.WorldLog != None)
					Level.Game.WorldLog.LogPickup(Self, P);
				P.Health += HealingAmount;
				if (P.Health > MaxHealth) P.Health = MaxHealth;
				PlayPickupMessage(P);
				PlaySound (PickupSound,,2.5);
				Other.MakeNoise(0.2);
				SetRespawn();
			}
		}
	}
}

defaultproperties
{
     bSuperHeal=False
     MaxHealth=500
     HealingAmount=50
     PickupMessage="You picked up a Health Pack"
     RespawnTime=10.000000
     Mesh=LodMesh'UnrealShare.HealthM'
     PickupSound=Sound'UnrealShare.Pickups.Health2'
     PickupViewMesh=LodMesh'UnrealShare.HealthM'
     Icon=Texture'UnrealShare.Icons.I_Health'
     CollisionRadius=22.000000
     CollisionHeight=8.000000
}
