//=============================================================================
// WarHeadLauncher
//=============================================================================
class NSWarHeadLauncher extends TournamentWeapon;

#exec OBJ LOAD FILE=..\Textures\LadrStatic.utx PACKAGE=Botpack.LadrStatic //Yep, like ChallengeHUD... Crap I have to fix Monster View too

var NSGuidedWarShell GuidedShell;
var int Scroll;
var PlayerPawn GuidingPawn;
var bool	bGuiding, bCanFire, bShowStatic;
var rotator StartRotation;

replication
{
	reliable if( bNetOwner && (Role==ROLE_Authority) )
	bGuiding, bShowStatic;
}

function SetWeaponStay()
{
	bWeaponStay = false; // redeemer never stays
}

simulated function PlaySelect()
{
	bForceFire = false;
	bForceAltFire = false;
	bCanClientFire = false;
	if ( ( mesh != mesh'WHPick') && (!IsAnimating() || (AnimSequence != 'Select')) )
		PlayAnim('Select',1.0,0.0);
	if ( Owner != None )
		Owner.PlaySound(SelectSound, SLOT_Misc, Pawn(Owner).SoundDampening);
}

simulated function PostRender( canvas Canvas )
{
	local int i, numReadouts, OldClipX, OldClipY;
	local float XScale;

	bOwnsCrossHair = ( bGuiding || bShowStatic );
	if ( !bGuiding )
	{
		if ( !bShowStatic )
			return;
		Canvas.SetPos(0,0);
		if ( Level.bHighDetailMode )
			Canvas.Style = ERenderStyle.STY_Translucent;
		else
			Canvas.Style = ERenderStyle.STY_Normal;
		Canvas.DrawIcon(Texture'LadrStatic.Static_a00', FMax(Canvas.ClipX, Canvas.ClipY)/256.0);
		if ( Owner.IsA('PlayerPawn') )
			PlayerPawn(Owner).ViewTarget = None;
		return;
	}
	GuidedShell.PostRender(Canvas);
	OldClipX = Canvas.ClipX;
	OldClipY = Canvas.ClipY;
	XScale = FMax(0.5, int(Canvas.ClipX/640.0));
	Canvas.SetPos( 0.5 * OldClipX - 128 * XScale, 0.5 * OldClipY - 128 * XScale );
	if ( Level.bHighDetailMode )
		Canvas.Style = ERenderStyle.STY_Translucent;
	else
		Canvas.Style = ERenderStyle.STY_Normal;
	Canvas.DrawIcon(Texture'GuidedX', XScale);

	numReadouts = OldClipY/128 + 2;
	for ( i = 0; i < numReadouts; i++ )
	{
		Canvas.SetPos(1,Scroll + i * 128);
		Scroll--;
		if ( Scroll < -128 )
			Scroll = 0;
		Canvas.DrawIcon(Texture'Readout', 1.0);
	}
	Super.PostRender(Canvas);
}

function float RateSelf( out int bUseAltMode )
{
	local float EnemyDist, Rating;
	local bool bRetreating;
	local vector EnemyDir;
	local Pawn P, Ow;
	local int Enemies;

	Enemies = 0;
	//Ripp from RocketLauncher, a better code for weaponry with SplashDamage
	// don't recommend self if out of ammo
	if ( AmmoType.AmmoAmount <=0 )
		return -2;
	// by default use regular mode (rockets)
	bUseAltMode = 0;
	Ow = Pawn(Owner);
	if ( Ow.Enemy == None || Ow.Enemy.bDeleteMe )
		return -2;
	// if standing on a lift, make sure not about to go around a corner and lose sight of target
	// (don't want to blow up a rocket in bot's face)
	if ( (Ow.Base != None) && (Ow.Base.Velocity != vect(0,0,0))
		&& !Ow.CheckFutureSight(0.1) )
		return -2;
	if (Ow.Enemy != None)
	{
		EnemyDir = Ow.Enemy.Location - Ow.Location; 
		EnemyDist = VSize(EnemyDir);
		Rating = AIRating;
		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		{
			if ( P != None && P.Health >= 199
			&& (!P.bIsPlayer || P.PlayerReplicationInfo == None )
			&& VSize(Ow.Enemy.Location - P.Location ) < 300
			&& Ow.Enemy.LineOfSightTo(P) && P != Ow.Enemy )
				Enemies++;
		}
		if ( Enemies >= 5 ) return Rating += 1.0; //Devil trigger bad things
		// don't pick this one if enemy is too close
		if ( EnemyDist > 1600 )
		{
			if ( Ow.Weapon == self )
			{
				// don't switch away from Weapon unless really bad tactical situation
				if ( (EnemyDist < 700) || ((Ow.Health < 50) && (Ow.Health < Ow.Enemy.Health - 120)) )
				return Rating;
			}
			return 0.05 + EnemyDist * 0.001;
		}

	// increase rating for situations for which this Wepsy is well suited
	if ( Ow.Enemy.IsA('StationaryPawn') )
		Rating += 0.4;

	// rockets are good if higher than target, bad if lower than target
	if ( Ow.Location.Z > Ow.Enemy.Location.Z + 120 )
		Rating += 0.2;
	else if ( Ow.Enemy.Location.Z > Ow.Location.Z + 160 )
		Rating -= 0.4;
	else if ( Ow.Enemy.Location.Z > Ow.Location.Z + 80 )
		Rating -= 0.2;
	}
	return Rating;
}
/*
function float RateSelf( out int bUseAltMode )
{
	local Pawn P, E;
	local Bot O;

	O = Bot(Owner);
	if ( (O == None) || (AmmoType.AmmoAmount <=0) || (O.Enemy == None) )
		return 0;
	bUseAltMode = 0;
	E = O.Enemy;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
	{
		if ( P != None && P.bIsPlayer && (P != O) && (P != E) && (O != None) && (E != None)
			&& (!Level.Game.bTeamGame || ((O.PlayerReplicationInfo.Team != P.PlayerReplicationInfo.Team) && E.PlayerReplicationInfo != None ) || E.PlayerReplicationInfo == None )
			&& (VSize(E.Location - P.Location) < 650)
			&& (!Level.Game.IsA('TeamGamePlus') || TeamGamePlus(Level.Game).PriorityObjective(O) < 2)
			&& FastTrace(P.Location, E.Location) )
		{
			if ( VSize(E.Location - O.Location) > 1400 )
				return 1;
			else if ( VSize(E.Location - O.Location) <= 1400 )
				return 0;
			else return 0.5;
		}
	}
	return 0.95;
}
*/
// return delta to combat style
function float SuggestAttackStyle()
{
	local float EnemyDist;
	local Pawn P;

	// recommend backing off if target is too close or attack if more enemies might be damaged
	if (Pawn(Owner).Enemy != None)
	{
		EnemyDist = VSize(Pawn(Owner).Enemy.Location - Owner.Location);
	}
	if ( EnemyDist < 2200 )
	{
		if ( EnemyDist < 1800 )
			return -2.5;
		else
			return -1.9;
	}
	else return 0.4;
}

function float SuggestDefenseStyle()
{
	return 1.0;
}

simulated function PlayFiring()
{
	PlayAnim( 'Fire', 0.3 );
	PlayOwnedSound(FireSound, SLOT_None,4.0*Pawn(Owner).SoundDampening);
	if ( Pawn(Owner) != None && Pawn(Owner).PlayerReplicationInfo == None )
		AmmoType.AmmoAmount = 2;
}

function setHand(float Hand)
{
	if ( Hand == 2 )
	{
		bHideWeapon = true;
		return;
	}
	else
		bHideWeapon = false;

	PlayerViewOffset.Y = Default.PlayerViewOffset.Y;
	PlayerViewOffset.X = Default.PlayerViewOffset.X;
	PlayerViewOffset.Z = Default.PlayerViewOffset.Z;

	PlayerViewOffset *= 100; //scale since network passes vector components as ints
}

function Projectile ProjectileFire(class<projectile> ProjClass, float ProjSpeed, bool bWarn)
{
	local Vector Start, X,Y,Z;
	local Pawn PawnOwner;
	local Pawn P;
	local Projectile MyProjectile;

	PawnOwner = Pawn(Owner);
	Owner.MakeNoise(PawnOwner.SoundDampening);
	GetAxes(PawnOwner.ViewRotation,X,Y,Z);
	Start = Owner.Location + CalcDrawOffset() + FireOffset.X * X + FireOffset.Y * Y + FireOffset.Z * Z;
	AdjustedAim = PawnOwner.AdjustAim(ProjSpeed, Start, AimError, True, bWarn);

	MyProjectile = Spawn(ProjClass,,, Start,AdjustedAim);
	MyProjectile.SetOwner(Owner);

 	if (/*PawnOwner.IsA('TournamentPlayer') && */ PawnOwner.bIsPlayer)
	{ // only send message when players fire deemer - Are you kidding ? LOL !
		BroadcastMessage (PawnOwner.GetHumanName()@"FIRED A REDEEMER");
		for ( P=Level.PawnList; P != None; P=P.nextPawn )
		{ // work through pawn list
			if ( P.bIsPlayer || P.IsA('MessagingSpectator') )
			{ // see if player
				if ( P.IsA('TournamentPlayer') && P != PawnOwner)
				{
				P.ReceiveLocalizedMessage(Class'DeemerLaunchMsg',,PawnOwner.PlayerReplicationInfo);
				}
			} // see if player
		} // work through pawn list
	} // only send message when players fire deemer
	return MyProjectile;
}

function AltFire( float Value )
{
	if ( !Owner.IsA('PlayerPawn') )
	{
		Fire(Value);
		return;
	}

	if (AmmoType.UseAmmo(1))
	{
		PlayerPawn(Owner).ShakeView(ShakeTime, ShakeMag, ShakeVert);
		bPointing=True;
		Pawn(Owner).PlayRecoil(FiringSpeed);
		PlayFiring();
		GuidedShell = NSGuidedWarShell(ProjectileFire(AltProjectileClass, ProjectileSpeed, bWarnTarget));
		GuidedShell.SetOwner(Owner);
		PlayerPawn(Owner).ViewTarget = GuidedShell;
		GuidedShell.Guider = PlayerPawn(Owner);
		ClientAltFire(0);
		GotoState('Guiding');
	}
}

simulated function bool ClientAltFire( float Value )
{
	if ( bCanClientFire && ((Role == ROLE_Authority) || (AmmoType == None) || (AmmoType.AmmoAmount > 0)) )
	{
		if ( Affector != None )
			Affector.FireEffect();
		PlayOwnedSound(FireSound, SLOT_None,4.0*Pawn(Owner).SoundDampening);
		return true;
	}
	return false;
}

State Guiding
{
	function Fire ( float Value )
	{
		if ( !bCanFire )
			return;
		if ( GuidedShell != None )
			GuidedShell.Explode(GuidedShell.Location,Vect(0,0,1));
		bCanClientFire = true;

		GotoState('Finishing');
	}

	function AltFire ( float Value )
	{
		Fire(Value);
	}

	function BeginState()
	{
		Scroll = 0;
		bGuiding = true;
		bCanFire = false;
		if ( Owner.IsA('PlayerPawn') )
		{
			GuidingPawn = PlayerPawn(Owner);
			StartRotation = PlayerPawn(Owner).ViewRotation;
			PlayerPawn(Owner).ClientAdjustGlow(-0.2,vect(200,0,0));
		}
	}

	function EndState()
	{
		bGuiding = false;
		if ( GuidingPawn != None )
		{
			GuidingPawn.ClientAdjustGlow(0.2,vect(-200,0,0));
			GuidingPawn.ClientSetRotation(StartRotation);
			GuidingPawn = None;
		}
	}


Begin:
	Sleep(1.0);
	bCanFire = true;
}

State Finishing
{
	ignores Fire, AltFire;

	function BeginState()
	{
		bShowStatic = true;
	}

Begin:
	Sleep(0.3);
	bShowStatic = false;
	Sleep(1.0);
	GotoState('Idle');
}

defaultproperties
{
     WeaponDescription="Classification: Thermonuclear Device"
     InstFlash=-0.400000
     InstFog=(X=950.000000,Y=650.000000,Z=290.000000)
     AmmoName=Class'MH2_NS_V2.NWarHeadAmmo'
     ReloadCount=1
     PickupAmmoCount=1
     bWarnTarget=True
     bAltWarnTarget=True
     bSplashDamage=True
     bSpecialIcon=True
     FiringSpeed=1.000000
     FireOffset=(X=18.000000,Z=-10.000000)
     ProjectileClass=Class'MH2_NS_V2.NSWarShell'
     AltProjectileClass=Class'MH2_NS_V2.NSGuidedWarshell'
     shakemag=350.000000
     shaketime=0.200000
     shakevert=7.500000
     AIRating=0.900000
     RefireRate=4.000000
     AltRefireRate=5.000000
     FireSound=Sound'Botpack.Redeemer.WarheadShot'
     SelectSound=Sound'Botpack.Redeemer.WarheadPickup'
     DeathMessage="%o was vaporized by %k's %w!!"
     NameColor=(G=128,B=128)
     AutoSwitchPriority=10
     InventoryGroup=10
     PickupMessage="You got The Redeemer."
     ItemName="Redeemer"
     RespawnTime=90.000000
     PlayerViewOffset=(X=1.800000,Y=1.000000,Z=-1.890000)
     PlayerViewMesh=LodMesh'Botpack.WarHead'
     BobDamping=0.975000
     PickupViewMesh=LodMesh'Botpack.WHPick'
     ThirdPersonMesh=LodMesh'Botpack.WHHand'
     StatusIcon=Texture'Botpack.Icons.UseWarH'
     PickupSound=Sound'UnrealShare.Pickups.WeaponPickup'
     Icon=Texture'Botpack.Icons.UseWarH'
     Mesh=LodMesh'Botpack.WHPick'
     bNoSmooth=False
     CollisionRadius=45.000000
     CollisionHeight=23.000000
}
