//=============================================================================
// mhflashlight.
//=============================================================================
class mhflashlight extends TournamentPickup;

var FlashLightBeam s;
var float TimeChange;
var Vector HitNormal,HitLocation,EndTrace,StartTrace,X,Y,Z,NewHitLocation;

event float BotDesireability( pawn Bot )
{
	local inventory Inv;

	for ( Inv=Bot.inventory; Inv!=None; Inv=Inv.inventory )

		if ( Inv.IsA('mhflashlight') || Inv.IsA('FlashLight') )
			return -2; //LOL

	return Super.BotDesireability(Bot);
}

function bool HandlePickupQuery( inventory Item )
{
	local Inventory S;

	if ( item.class == class ) 
	{
		S = Pawn(Owner).FindInventoryType(class'mhflashlight');
		if (  S != None )
		{
			if ( Charge > S.Charge/3)
				return True;
			else
				Charge = S.Charge;
		}
/*		else
			Charge = Clamp(S.Default.Charge - S.Charge, Charge, Item.Charge );
*/
		if (Level.Game.LocalLog != None)
			Level.Game.LocalLog.LogPickup(Item, Pawn(Owner));
		if (Level.Game.WorldLog != None)
			Level.Game.WorldLog.LogPickup(Item, Pawn(Owner));
		if ( PickupMessageClass == None )
			Pawn(Owner).ClientMessage(PickupMessage, 'Pickup');
		else
			Pawn(Owner).ReceiveLocalizedMessage( PickupMessageClass, 0, None, None, Self.Class );
		Item.PlaySound (PickupSound,,2.0);
		Item.SetReSpawn();
		return true;
	}
	if ( Inventory == None )
		return false;

	return Inventory.HandlePickupQuery(Item);
}

state Activated
{
	function endstate()
	{
		if (s!=None) s.Destroy();
		bActive = false;
	}

	function Tick( float DeltaTime )
	{
		if ( bDeleteMe ) return;
		if ( Pawn(Owner) == None )
		{
			if (s != None)
				s.Destroy();
			Destroy();
			return;
		}
		if (Charge <= 0)
		{
			if (s != None)
				s.Destroy();
			Pawn(Owner).ClientMessage(ExpireMessage);
			UsedUp();
			return; //?
		}
		if (s == None)
		{
			GoToState('DeActivated');
			Return;
		}
		TimeChange += DeltaTime*10;
		if (TimeChange > 1)
		{
			if ( s == None )
			{
				UsedUp();
				return; //?
			}		
			Charge -= int(TimeChange);
			TimeChange = TimeChange - int(TimeChange);
		}

		if (Charge<300) s.LightBrightness=byte(Charge*0.8+10);
		GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);
		EndTrace = Pawn(Owner).Location + 10000* Vector(Pawn(Owner).ViewRotation);
		Trace(HitLocation,HitNormal,EndTrace,Pawn(Owner).Location, True);
		s.SetLocation(HitLocation-vector(Pawn(Owner).ViewRotation)*64);
//		s.LightRadius = fmin(Vsize(HitLocation-Pawn(Owner).Location)/200,14) + 2.0;
	}

	function BeginState()
	{
		TimeChange = 0;
		if (Owner != None)
		{
			Owner.PlaySound(ActivateSound);
			GetAxes(Pawn(Owner).ViewRotation,X,Y,Z);
			EndTrace = Pawn(Owner).Location + 10000* Vector(Pawn(Owner).ViewRotation);
			Trace(HitLocation,HitNormal,EndTrace,Pawn(Owner).Location+Y*17);
			s = Spawn(class'FlashLightBeam',Owner, '', HitLocation+HitNormal*40);
			s.LightHue = LightHue;
			s.LightRadius = LightRadius;
			if (Charge<300) s.LightBrightness=byte(Charge*0.8+10);
		}
		if (s==None) GoToState('DeActivated');
	}

Begin:
}

state DeActivated
{
Begin:
	if ( s != None )
		s.Destroy();
	if (Owner != None)
		Owner.PlaySound(DeActivateSound);
}

defaultproperties
{
     ExpireMessage="Flashlight batteries have died."
     bAutoActivate=True
     bActivatable=True
     bDisplayableInv=True
     PickupMessage="You picked up the Flashlight."
     ItemName="FlashLight"
     RespawnTime=10.000000
     MaxDesireability=2.000000
     PickupViewMesh=LodMesh'UnrealShare.Flashl'
     Charge=10000
     PickupSound=Sound'UnrealShare.Pickups.GenPickSnd'
     ActivateSound=Sound'UnrealShare.Pickups.FSHLITE1'
     DeActivateSound=Sound'UnrealShare.Pickups.FSHLITE2'
     Icon=Texture'UnrealShare.Icons.I_Flashlight'
     RemoteRole=ROLE_DumbProxy
     Mesh=LodMesh'UnrealShare.Flashl'
     AmbientGlow=96
     CollisionRadius=22.000000
     CollisionHeight=4.000000
     LightBrightness=110
     LightHue=33
     LightSaturation=187
     LightRadius=7
}
